*******************************************************************************
*                                                                             *
*                                                                             *
*                     T I G C C   T o o l s   S u i t e                       *
*                                                                             *
*                                    by                                       *
*                                                                             *
*                          The TI-Chess Team (TiCT)                           *
*                                                                             *
*                                                                             *
*                                                                             *
*                      R E V I S I O N    H I S T O R Y                       *
*                                                                             *
*                                                                             *
*******************************************************************************
$Id: history.txt,v 1.19 2002/05/27 07:59:01 tnussb Exp $

===============================================================================
TIGCC Tools Suite 1.31 (27/05/2002)
===============================================================================
ttstart.c: exception handling added (thanx to Sebastian Reichelt)


===============================================================================
TIGCC Tools Suite 1.30 - INTERNAL BETA (23/05/2002)
===============================================================================
ttbin2hex: Bug fixed. If length of file wasn't a multiple of the itemsize the
           generated length of the array (-a option) was off by one
ttbin2hex: commandline switch -lb added. This switch can be used to add an
           additionally linebreak after every n items. This is useful if
           you convert for example multiple small images of the same size in
           one rush and you want to know in the output where a new image starts.
ttbin2oth: (1) usage text modified: Hint about reserved AMS names added.
           (2) TT_MAX_OTHDATA corrected/statically header information fixed
               - thanx to Sebastian Reichelt
ttunpack.h: stepped back to old unpacking code, because under some specific
            conditions the calc crashes with an ER_throw (TRAP $F) after
            executing a packed program. I haven't had the time to fix the new
            version, but stepping back to the old code will do the job, too.
ebook.c:    version number raised to reflect the use of the old unpacking
            function


===============================================================================
TIGCC Tools Suite 1.25 (17/04/2002)
===============================================================================
tthex2bin: very handy PC tool to convert hex or binary numbers from a textfile
           into a binary file added. I just wonder why no one has requested
           such a tool until now ...

ttrow: Thanx to Peter J. Rowe (mig53@yahoo.com) I can add this new calc tool to
       the TIGCC Tools Suite. The following text is from the Peter's original
       readme.txt file:

       [quote]
       This is a simple program that I wrote to help me when I am using
       _rowread in my programs. The bit numbers across the top and the row
       numbers down the left side are the same as in the documentation. The hex
       numbers on the right side are the numbers that you would pass into
       _rowread to read the row corresponding to the row number on the left
       side of the grid. The numbers across the bottom are two to the power of
       the bit number, for easy anding to get a specific key. When you press a
       key, the appropriate cell of the grid is shaded.
       [/quote]

ttproto: generated prototypes modernized and extended

ttextract: (1) closing of files added to end of program
           (2) treatment of -v (verbose) added
           (3) treatment of -quiet (suppress standard messages) added
           (4) bug fixed (if no endtoken was given, a wrong endpos was evaluated)

ttbin2hex: (1) treatment of -quiet (suppress standard messages) added
           (2) option -ss (skip bytes at begin of inputfile) added
           (3) option -se (skip bytes at end of inputfile) added

ebook.c: again some size and speed optimizations done by Francesco Orabona
         (bremen79@infinito.it)


===============================================================================
TIGCC Tools Suite 1.20 (14/03/2002)
===============================================================================
bin2oth.c: (1) function can handle now between 1 and 4 characters as extension

ttbin2oth: (1) supports now between 1 and 4 characters as extension
           (2) new flag "-quiet" added (suppress standard messages)
           (3) new flag "-strip" added (strip TI header before OTH generation)
               With this new flag it is possible to convert any TI file in
               one step into an OTH file without the need of using TTStrip
               before.
           (4) Usage text completely rewritten

ttstrip:   (1) new flag "-quiet" added (suppress standard messages)
           (2) usage text completely rewritten

ttppggen:  (1) new flag "-quiet" added (suppress standard messages)
           (2) use "-quiet" as parameter for ttbin2oth and ttstrip calls
           (3) printing of statistics if successfully completes added
           (4) checking of inputfile extension fixed
           (5) usage text modified

ttarchive: (1) by adding the word "compress" at the end of a line in the
               configuration file, ttarchive will automatically compress
               this file now, before adding it to the archive
           (2) new flag "-quiet" added (suppress standard messages)
           (3) specifying of extensions between 1 and 4 characters is possible now
           (4) usage text adapted

ttpack:    (1) new flag "-quiet" added (suppress standard messages)

ttebkgen:  (1) new commandline parameter -89 (generate only TI89 ebook)
           (2) new commandline parameter -92 (generate only TI92p ebook)
           (3) new commandline parameter -v (verbose)
           (4) new commandline parameter -quiet (suppress standard messages)
           (5) internal TTBin2Bin usage replaced by second call to TTArchive
           (6) internal TTPack usage removed (is now handled by TTArchive itself)

ttbin2bin: (1) new commandline parameter -quiet (suppress standard messages)

docs:       ebook-readme.html updated / ttstart-readme.html added
ttdos2ebk:  typo in PrintUsage() fixed
ebook.c:    minor size optimizations by Francesco Orabona (bremen79@infinito.it)
unpack.c:   directory src/calctools/old contains now the following new files:
            unpack.c / extract.bat
            These files can be used to semi-automatically generate the hexcode
            array of the exepack decompression function which is part of
            ttunpack.h
ttunpack.h: new hexcode array of exepack decompression function added. Its now
            smaller by around 50 bytes ...
ttstart.c: (1) some messages shortened
           (2) using now new and minor size optimized unpacking function
           (3) some comments added
tthedit.c: uses now own function PrintAddress() instead of redefining macro
           printf_xy. PrintAddress() should be much faster as the previous use
           of sprintf().
alice.txt: the wrong link to the TICT-HQ at the end of "Alice in Wonderland"
           fixed

batchfiles of examples "alice" and "tribute" modified to use now features
of ttarchive and ttebkgen.

Directory src/experimental added. This directory contains unfinished TIGCC Tools
like an ttpack version for the calculator (compiles, but doesn't work).


===============================================================================
TIGCC Tools Suite 1.10 BETA (04/03/2002)
===============================================================================

NOTE: The changes done for 1.10 are quite huge (see list below). Therefore I
      will release this version marked as BETA. Nevertheless everything should
      work as expected.

eBookReader modifications:

(1) Thanx to Austin Chu (qarv@yahoo.com) for pointing me out how stupid
    and therefore slow NextLine() was implemented previously
(2) many parts rewritten to optimize the codesize which is necessary for the
    statusline restoring handling (see below)
(3) "white on black" text is now drawn with FastStringXY, too
(4) uses now FillFullLines macro instead of RectFill()
(5) previously set font will be restored now before exit
(6) FontSetSys() only used in CharSet grabbing, because all 4x6 strings
    are now drawn by FastStringXY
(7) I have moved the bottom line to the top, because I think this way
    reading the text is a little bit easier.
(8) uses now an own INT5 handler to restore the statusline area if it
    gets destroyed by one of the statusline indicators.

(*) ttstart.c: fix of EX_patch call to be prepared for the new EX_patch version
               which will come with AMS 2.06. Thanx to Kevin Kofler for the fix
(*) ttstart.c: ExtendeD's (ola.e-ml@wanadoo.fr) relocation routine added just
               for the case EX_patch will break again (NOT enabled yet)
(*) ttbatt.c:  ttbatt code bugfixed again by ExtendeD (ola.e-ml@wanadoo.fr)
(*) tthedit.c: (1) bug in drawing routine fixed (missing mask-out of old data)
               (2) XOR_Cursor() completely rewritten
               (3) major speedup of page drawing by re-implementing
                   PrintLeftSideNumber and PrintRightSideChar() (not using
                   printf_xy() anymore).

(*) Almost all calctools optimized for size using "static const" for character
    arrays, "static inline" for "once used" functions and "-Os" and
    "-fomit-framepointer" for compiling. Additionally I have optimized some
    loops to reduce the speed.

(*) ttchecksum: Checks now if embedded file length matches real filelength.
                For example, if you transfer a binary file as textfile using
                FTP the filelength may be modified. Now ttchecksum detects
                such invalid files and reports a filelength missmatch.

(*) pctools: almost all PC tools are modified so that they can be used as
             compiled-in (embedded) versions from within another tool by just
             including the sourcecode. This way no installation of the TIGCC
             Tools Suite is necessary for proper operation of ttppggen and
             ttebkgen.

(*) TTPPGGen: can be distributed now as single file without the need of a
              TIGCC Tools Suite installation.

(*) TTEbkGen: can be distributed now as single file without the need of a
              TIGCC Tools Suite installation.


===============================================================================
TIGCC Tools Suite 1.00 final (25/02/2002)
===============================================================================
(*) ttmem:   bug in generation of variables fixed [xdanger]
(*) tthedit: speedup and size optimizations [xdanger]
             missing cleanup in exit points of main fixed [tnussb]
(*) tthdex:
   (1) optimization of the drawing routines in tthedit here too [xdanger]
   (2) added variation of the delay in DisplayHexPage (with [(] and [)],
       inlined and modified the waiting routine [xdanger]
   (3) modified FastestDrawLine, now it saves and restores d0, d1 and a0 [xdanger]
   (4) [2nd][UP] and [2nd][DOWN] now go up or down of 0x100 (89) or 0x200 (92+),
       No changes for [DIAMOND][UP] and [DIAMOND][DOWN]  [xdanger]
   (5) missing cleanup in some exit points of main fixed [tnussb]
   (6) NormalString() slightly modified to suppress complete recalculation
       of address [tnussb]
   (7) deprecation warning in inline assembler block fixed [tnussb]


===============================================================================
TIGCC Tools Suite 1.00 BETA7 (14/02/2002)
===============================================================================
(*) tthdex:  critical bug in redefinition of printf_xy fixed  (buffer size
             increased from 30 to 200)


===============================================================================
TIGCC Tools Suite 1.00 BETA6 (13/02/2002)
===============================================================================
(*) tthdex:  version number raised and minor code beautifying (backslashes
             removed from asm constructs)
(*) tthedit: (1) Small bugfix (bug occured only on 92+) [Lionel Debroux]
             (2) Size and speed optimizations (thanks to PsiGoo for giving me
                 the idea of using Sprite8_XOR and not ScrRectFill
                 [Lionel Debroux]
             (3) Speed optimizations by inlining sprite drawing into routines
                 (no separate sprite drawing routines anymore)


===============================================================================
TIGCC Tools Suite 1.00 BETA5 internal (13/02/2002)
===============================================================================
(*) ttunpack: option -t parsing fixed
(*) tthdex:   compiler warning in handle table retrieving line fixed now
(*) ebook:    (1) broken sprite drawing fixed again
              (2) FastDrawStringXY() heavily optimized by inlining the sprite
              (3) drawing and by unrolling the inner loop
              (4) uses now standard defines USE_TI89 and USE_TI92P instead of own
                  defines


===============================================================================
TIGCC Tools Suite 1.00 BETA4 internal (11/02/2002)
===============================================================================
(*) ttbatt:   complete new version implemented by Francesco Orabona
              (bremen79@infinito.it)
(*) ttmem:    adaptions for TIGCC 0.93 (Lionel Debroux)
(*) tthw:     adaptions for TIGCC 0.93 (Lionel Debroux)
(*) ebook:    (1) uses now dynamic memory allocation for screenbuffer (Lionel D.)
              (2) minor size optimizations
              (3) all warnings reported by -Wwrite-strings fixed
(*) tthdex:   bugfixes done by Lionel Debroux
(*) tthedit:  bugfixes done by Lionel Debroux


===============================================================================
TIGCC Tools Suite 1.00 BETA3 (07/02/2002)
===============================================================================
(*) recompilation with TIGCC 0.93 Beta Official Release (binary sizes may vary)
(*) stupid bug in tthw tool (display "calc or VTI") fixed again
    (lost in BETA1/BETA2)
(*) directory bin92 renamed to bin92p
(*) directory src/include removed (all header files moved to src/pctools and
    all pctool sources changed to use the new include path)
(*) everything checked-in into CVS repository to get the correct version
    numbers


===============================================================================
TIGCC Tools Suite 1.00 BETA2 (31/01/2002)
===============================================================================
ttbatt.c:      NEW CALCTOOL added which performs standalone battery level
               detection (based on the code of the TiCT-Explorer).
               Thanx to Lionel Debroux (xdanger1@caramail.com) for contributing
               this tool.

ttunarchive.c: NEW PCTOOL added which may be used to extract data from any
               ttarchive or to list its content

ttarchive.h:   macro GetEntrySize() added

ttppggen.c:    wrong calc signature in file will now only be reported, but don't
               break the conversion. I have also added a commandline switch
               (-nowarn) to suppress this warning if not wanted.

PRINT_ID:      now prints the version info on stdout instead of stderr
ttstart.c:     reduced by 12 bytes. Thanx to Sebastian Reichelt for the
               hint to use char[] instead of char*


===============================================================================
TIGCC Tools Suite 1.00 BETA (15/01/2002)
===============================================================================
In general the modifications in this release where done to utilize the features
of the new TIGCC version 0.93 and to support kernel-dependent exepacked
programs. Executable size changes in calc tools which were not modified are
due to the new compiler and TIGCCLIB versions.

tthw.c:    deprecated multi-line string literals replaced by correct form
tthedit.c: wrong declaration of main function fixed
ttstart.c: supports now kernel-dependent exepacked programs
ttstart.c: modifications to use new features of TIGCC 0.93
ttstart.c: uses now improved version of enter_ghost_space code from Kevin Kofler
ebook.c:   serious bug in bookmark dialog handling fixed (previously not wanted
           keys had escaped from the routine, too)
ebook.c:   [+] and [+] key can be used for paging
ebook.c:   possible problem with postincrementing variable in function call fixed
           (problem was reported by new TIGCC compiler version)
ebook.c:   utilizes now directive NO_EXIT_SUPPORT
tthedit.c: speedup version from Lionel Debroux (xdanger1@caramail.com) integrated
           using similar character drawing than ebook reader in combination with
           code from library extgraph
tthdex.c:  improved version from Lionel Debroux (xdanger1@caramail.com) integrated
           now supports byte/word/dword searching and generic memory view
           (executable tthdexm is the same as tthdex, but the help screen is stripped
            to keep the program size below the 8kB limit!!!)
pstarter:  folder tigcc_patch holds now new pstarter.o file (for TIGCC 0.93 and above)
ttproto.c: NO_EXIT_SUPPORT added to generated template
ttppggen.c: generating ppg files from kernel-dependent executables enables
ttstart.c: the commandline version of ttstart doesn't allow anymore starting itself
           (the same copy of itself), to prevent crashing

!!! PENDING: (1) UPDATE DOCS OF EBOOK READER!!
             (2) Check-in everything and force tthdex to version number 2.00


===============================================================================
TIGCC Tools Suite 0.99.1 (31/07/2001)
===============================================================================
buildone.bat:  using now -9 (compress better) for upx call
ttstart:       handles now RETURN_VALUE correctly
ttstart:       can be build now in many different ways (for example as generic
               launcher)
ttdasm:        -stub option implemented (printing of header info of stub progs)
ttproto:       changed type from int to short for _ti89,_ti92plus
all calctools: tools are now build with -W option (all compiler warnings beside
               one are fixed now)
folder tigcc:  folder tigcc added which holds a replacement of file
               include\c\pstarter.s of your TIGCC 0.91/0.91SP1 installation


===============================================================================
TIGCC Tools Suite 0.99 (20/06/2001)
===============================================================================
tttiler: (1) tilenumber output corrected
         (2) suppressing following comma after the last tile of a plane
         (3) writing now macros to access the tiles
         (4) handling of output redirection to stdout (outfilename == "-")
         (5) customizable arrayname (commandline parameter)
         (6) test program output adapted to TIGCC 0.90 (int -> short)

ebook reader: you can press now 'x' twice instead of 'x' and afterwards '0'

ttbin2hex: (1) handling of output redirection to stdout (outfilename == "-")
           (2) handling of "-a arrayname" to generate a complete C array of
               name arrayname

ttproto: using now GrayOn() and GrayOff() instead of old-style GrayMode() calls


===============================================================================
TIGCC Tools Suite 0.98-2 Internal (10/04/2001)
===============================================================================
(*) ttunebk: tool added (exports text from ebook)


===============================================================================
TIGCC Tools Suite 0.98-1 Internal (08/04/2001)
===============================================================================
(*) ebook reader: letter 'g' problem fixed
(*) ebook reader: using now idle() to save power


===============================================================================
TIGCC Tools Suite 0.98 (21/03/2001)
===============================================================================
(*) just minor cosmetic changes for another official beta release


===============================================================================
TIGCC Tools Suite 0.97-4 Internal (13/02/2001)
===============================================================================
(*) calctools: using now new versions of ttunpack.h/ttarchive.h
(*) ebook reader: using now 7 pixel per line for better readability
(*) tthdex: completely rewritten to show all handles
(*) all files which are related to the nostub library concept removed
(*) ttbin2hex: adding no comma after last item anymore
(*) ttbin2hex: -slash parameter added (adds a backslash on end of each line)
(*) ttbin2str: filling now PC file size bytes correctly (for very huge files)
(*) ttdasm: (1) generates labels automatically
            (2) generates compile-able code (not always, but almost always)
            (3) "-virtual" commandline flag added (adding just a virtual offset)
            (4) "-name" commandline flag added (turns on hints about possible
                ROM calls)
            (5) support for raw dumps added
            (6) support for VTI save files added
            (7) "-nolabels" commandline flag added (turn off label generation)
(*) tribute: using now new versions of ttunpack.h/ttarchive.h
(*) tthw added to calctools (tool to display infos from HWParamBlock)


===============================================================================
TIGCC Tools Suite 0.97-3 Internal (23/01/2001)
===============================================================================
(*) ebook: (1) speed up of output increased heavily (own drawing function)
           (2) reports now correctly out-of-memory instead of missing-title or
               missing-part
           (3) bug in bookmark file generation fixed
           (4) using now HANDLEs wherever possible and applicable instead of
               SYM_ENTRYs
           (5) all int's replaced with short's
(*) tthdex: HANDLE-Explorer calculator tool including complete documentation
            added (released standalone, too)


===============================================================================
TIGCC Tools Suite 0.97-2 Internal (16/01/2001)
===============================================================================
(*) ebook: now it should be save to install the reader even in the tictebks
           folder (ttslib.c fixed this way, too)


===============================================================================
TIGCC Tools Suite 0.97-1 Internal (14/01/2001)
===============================================================================
(*) ttinfo:     can operate now on 89z and 9xz files, too
(*) ttchecksum: can operate now on 89z and 9xz files, too
(*) calctools:  all problems stated by compiling with -Wall fixed
(*) calctools:  changes necessary for new TIGCC Library 2.31 (short<->int)
(*) ebook:      can handle now commandline argument string like "folder\file"
                own font 4x6 drawing routine to speed up page drawing
                key repeat feature added for cursor keys


===============================================================================
TIGCC Tools Suite 0.97 Official BETA RELEASE (02/12/2000)
===============================================================================
(*) some documentation added and fixed


===============================================================================
TIGCC Tools Suite 0.96-5 Internal (29/11/2000)
===============================================================================
(*) builddocs.bat added to pctools directory
(*) tttiler.c: bug fix - generate now correct test program for monochrome tiles
(*) define USAGE_OUT added to ttversion: now script builddocs.bat will work
    on Win95/98 systems, too
(*) all pc tools writing now their usage info to USAGE_OUT instead of stderr
(*) tthedit: (1) bug in edit keys treatment fixed
             (2) cursor wrap around added
(*) using now compile date and time for pctool header outputs instead of
    own TTV_DATE define
(*) ttbin2oth.c: unnecessary code removed
(*) ttproto.c: generated template modified to fit to TIGCC 0.8 features


===============================================================================
TIGCC Tools Suite 0.96-4 Internal (26/11/2000)
===============================================================================
(*) tttiler.c: inital version and preview release


===============================================================================
TIGCC Tools Suite 0.96-3 Internal (18/11/2000)
===============================================================================
(*) ttstart.c: using now enter_ghost_space() for sure
(*) ttarchive.h: bug in GetEntryStart macro fixed


===============================================================================
TIGCC Tools Suite 0.96-2 Internal (11/11/2000)
===============================================================================
(*) linux support files added (linux_readme.txt & linuxlinux.sh)


===============================================================================
TIGCC Tools Suite 0.96 Internal (18/10/2000)
===============================================================================
(*) ttebkgen.c: filecopy is done now by own routine instead of system() call
                to support linux
(*) asm_upck.c: email address of Denis fixed


===============================================================================
TIGCC Tools Suite 0.95 Official BETA RELEASE (01/10/2000)
===============================================================================
(*) some documentation added and fixed


===============================================================================
TIGCC Tools Suite 0.17 Internal (20/08/2000)
===============================================================================
(*) Example "eBook Reader" added containing eBook "Alice in Wonderland"
(*) TTDos2EBK added (prepares dos text file for eBook Usage)
(*) ttarchive.h added (structures,defines and macros to access TTArchive)
(*) TTArchive: flag -e <extension> added to build archives with personalized
               on-calculator extension like the eBooks (.ebk)
(*) TTUnPack added


===============================================================================
TIGCC Tools Suite 0.15 Internal (17/08/2000)
===============================================================================
(*) on-calc tool TTStart added
(*) TTArchive added
(*) TTPack added
(*) Example "Tribute to Gary Larson" added


===============================================================================
TIGCC Tools Suite 0.12 Internal (15/08/2000)
===============================================================================
(*) on-calc tool TTMem added


===============================================================================
TIGCC Tools Suite 0.11 Internal (14/08/2000)
===============================================================================
(*) pctool TTBin2Oth added
(*) on-calc tool TTStart added


===============================================================================
TIGCC Tools Suite 0.10 Preview Release (13/08/2000)
===============================================================================
(*) pctool TTBin2Str added
(*) pctool TTExtract added
(*) pctool TTStrip added
(*) pctool TTBin2Hex added

